<?php

namespace HCM\FPA\Repository;

use Doctrine\ORM\EntityManager;
use HCM\Util\HCMParameters;

class ReajusteRepository {

    protected  $connection;
    public function __construct(EntityManager $entityManager, HCMParameters $hcmParameters) {
        $this->entityManager = $entityManager;
        $this->hcmParameters = $hcmParameters;
    }

    public function getHistoricoAlteSalario($nrorg, $nrvinculom, $dtaltesalariojuste)
    {
        $sql = $this->entityManager->getConnection()->prepare("
            SELECT 
                DTALTESALARIO
            FROM 
                GPE_ALTESALARIO
            WHERE NRORG     = :P_NRORG
            AND NRVINCULOM  = :P_NRVINCULOM
            AND DTALTESALARIO >= :P_DTALTESALARIOREAJUSTE
        ");

        $sql->execute(
            array(
                "P_NRORG"=>$nrorg,
                "P_NRVINCULOM"=>$nrvinculom,
                "P_DTALTESALARIOREAJUSTE"=>$dtaltesalariojuste
            )   
        );
        
        $result = $sql->fetchAll();
        return !$result ? false : $result;
    }
    
    public function getFaixaTabela($nrorg,$codigo){
        $sql = $this->entityManager->getConnection()->prepare("
        SELECT * 
          FROM FPA_FAIXATABELA
         WHERE NRORG = :P_NRORG
           AND NRTABELAFOLHA = :P_NRTABELAFOLHA
           AND DTINIVIGENCIA = (SELECT MAX(DTINIVIGENCIA)
                                  FROM FPA_FAIXATABELA H1
                                 WHERE H1.NRORG = FPA_FAIXATABELA.NRORG
                                   AND H1.NRTABELAFOLHA = FPA_FAIXATABELA.NRTABELAFOLHA
                                   AND H1.DTINIVIGENCIA <= :P_DTMESCOMPETENC)
        ");
        $sql->execute(
            array(
                "P_NRORG"=>$nrorg,
                "P_NRTABELAFOLHA"=>$codigo,
                "P_DTMESCOMPETENC"=>$this->hcmParameters->getDtCompetencia(),
            )   
        );
        return $sql->fetchAll();
    }

}